"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _path = require("path");

var _objectPath = _interopRequireDefault(require("object-path"));

var _Adapter2 = _interopRequireDefault(require("./Adapter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var JsonFile = /*#__PURE__*/function (_Adapter) {
  _inherits(JsonFile, _Adapter);

  var _super = _createSuper(JsonFile);

  function JsonFile() {
    var _this;

    var dbOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, JsonFile);

    _this = _super.call(this, dbOptions);
    var _dbOptions$initalData = dbOptions.initalData,
        initalData = _dbOptions$initalData === void 0 ? {} : _dbOptions$initalData,
        _dbOptions$filePath = dbOptions.filePath,
        filePath = _dbOptions$filePath === void 0 ? (0, _path.join)(process.cwd(), 'node-realtime-db.json') : _dbOptions$filePath;
    _this.jsonFilePath = filePath;

    var exist = _fsExtra["default"].existsSync(filePath);

    if (!exist) {
      _fsExtra["default"].writeJsonSync(_this.jsonFilePath, initalData);
    }

    return _this;
  }

  _createClass(JsonFile, [{
    key: "get",
    value: function () {
      var _get = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(path) {
        var data;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _fsExtra["default"].readJson(this.jsonFilePath);

              case 2:
                data = _context.sent;
                return _context.abrupt("return", _objectPath["default"].get(data, path, undefined));

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function get(_x) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: "update",
    value: function () {
      var _update = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(path, newValue) {
        var data;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _fsExtra["default"].readJson(this.jsonFilePath);

              case 2:
                data = _context2.sent;

                _objectPath["default"].set(data, path, newValue);

                _context2.next = 6;
                return _fsExtra["default"].writeJson(this.jsonFilePath, data);

              case 6:
                return _context2.abrupt("return", newValue);

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function update(_x2, _x3) {
        return _update.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "incr",
    value: function () {
      var _incr = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(path, toIncr, value) {
        var data, newValue;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return _fsExtra["default"].readJson(this.jsonFilePath);

              case 2:
                data = _context3.sent;
                newValue = value + toIncr;

                _objectPath["default"].set(data, path, newValue);

                _context3.next = 7;
                return _fsExtra["default"].writeJson(this.jsonFilePath, data);

              case 7:
                return _context3.abrupt("return", newValue);

              case 8:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function incr(_x4, _x5, _x6) {
        return _incr.apply(this, arguments);
      }

      return incr;
    }()
  }, {
    key: "decr",
    value: function () {
      var _decr = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(path, toDecr, value) {
        var data, newValue;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return _fsExtra["default"].readJson(this.jsonFilePath);

              case 2:
                data = _context4.sent;
                newValue = value - toDecr;

                _objectPath["default"].set(data, path, newValue);

                _context4.next = 7;
                return _fsExtra["default"].writeJson(this.jsonFilePath, data);

              case 7:
                return _context4.abrupt("return", newValue);

              case 8:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function decr(_x7, _x8, _x9) {
        return _decr.apply(this, arguments);
      }

      return decr;
    }()
  }, {
    key: "push",
    value: function () {
      var _push = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(path, item, value) {
        var data, newValue;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return _fsExtra["default"].readJson(this.jsonFilePath);

              case 2:
                data = _context5.sent;
                newValue = [].concat(_toConsumableArray(value), [item]);

                _objectPath["default"].set(data, path, newValue);

                _context5.next = 7;
                return _fsExtra["default"].writeJson(this.jsonFilePath, data);

              case 7:
                return _context5.abrupt("return", newValue);

              case 8:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function push(_x10, _x11, _x12) {
        return _push.apply(this, arguments);
      }

      return push;
    }()
  }, {
    key: "unshift",
    value: function () {
      var _unshift = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(path, item, value) {
        var data, newValue;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return _fsExtra["default"].readJson(this.jsonFilePath);

              case 2:
                data = _context6.sent;
                newValue = [item].concat(_toConsumableArray(value));

                _objectPath["default"].set(data, path, newValue);

                _context6.next = 7;
                return _fsExtra["default"].writeJson(this.jsonFilePath, data);

              case 7:
                return _context6.abrupt("return", newValue);

              case 8:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function unshift(_x13, _x14, _x15) {
        return _unshift.apply(this, arguments);
      }

      return unshift;
    }()
  }, {
    key: "splice",
    value: function () {
      var _splice = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(path, args, value) {
        var data, arr;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return _fsExtra["default"].readJson(this.jsonFilePath);

              case 2:
                data = _context7.sent;
                arr = _toConsumableArray(value);
                arr.splice.apply(arr, _toConsumableArray(args));

                _objectPath["default"].set(data, path, arr);

                _context7.next = 8;
                return _fsExtra["default"].writeJson(this.jsonFilePath, data);

              case 8:
                return _context7.abrupt("return", arr);

              case 9:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function splice(_x16, _x17, _x18) {
        return _splice.apply(this, arguments);
      }

      return splice;
    }()
  }]);

  return JsonFile;
}(_Adapter2["default"]);

var _default = JsonFile;
exports["default"] = _default;