"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Adapter", {
  enumerable: true,
  get: function get() {
    return _Adapter["default"];
  }
});
Object.defineProperty(exports, "JsonFileAdapter", {
  enumerable: true,
  get: function get() {
    return _JsonFile["default"];
  }
});
exports["default"] = void 0;

var _socket = _interopRequireDefault(require("socket.io"));

var _Db = _interopRequireDefault(require("./Db"));

var _Adapter = _interopRequireDefault(require("./adapters/Adapter"));

var _JsonFile = _interopRequireDefault(require("./adapters/JsonFile"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = function _default(httpServer) {
  var ioOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var dbOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var _ioOptions$path = ioOptions.path,
      path = _ioOptions$path === void 0 ? '/rtdb' : _ioOptions$path;
  var io = new _socket["default"](httpServer, _objectSpread(_objectSpread({}, ioOptions), {}, {
    path: path
  }));
  var db = new _Db["default"](io, dbOptions);
  return {
    io: io,
    db: db
  };
};

exports["default"] = _default;